KD SOAP API Documentation: KDSoapJob Class Reference

| KD SOAP API Documentation 2.2

Loading...
Searching...
No Matches
Signals | Public Member Functions | Protected Member Functions | List of all members
KDSoapJob Class Referenceabstract

KDSoapJob provides a job-based interface to handle asynchronous KD Soap calls. More...

`#include <KDSoapJob.h>`

Inheritance diagram for KDSoapJob:
[legend]
Collaboration diagram for KDSoapJob:
[legend]

## Signals
void | finished (KDSoapJob *job)

## Public Member Functions
| KDSoapJob (QObject *parent=nullptr)
| ~KDSoapJob ()
QString | faultAsString () const
bool | isFault () const
KDSoapMessage | reply () const
KDSoapHeaders | replyHeaders () const
KDSoapHeaders | requestHeaders () const
void | setAutoDelete (bool enable)
void | setRequestHeaders (const KDSoapHeaders &headers)
void | start ()
Public Member Functions inherited from QObject
| QObject (QObject *parent)
virtual | ~QObject ()
bool | blockSignals (bool block)
const QObjectList & | children () const const
QMetaObject::Connection | connect (const QObject *sender, const char *signal, const char *method, Qt::ConnectionType type) const const
void | deleteLater ()
void | destroyed (QObject *obj)
bool | disconnect (const char *signal, const QObject *receiver, const char *method) const const
bool | disconnect (const QObject *receiver, const char *method) const const
void | dumpObjectInfo ()
void | dumpObjectInfo () const const
void | dumpObjectTree ()
void | dumpObjectTree () const const
QList< QByteArray > | dynamicPropertyNames () const const
virtual bool | event (QEvent *e)
virtual bool | eventFilter (QObject *watched, QEvent *event)
T | findChild (const QString &name, Qt::FindChildOptions options) const const
QList< T > | findChildren (const QRegExp &regExp, Qt::FindChildOptions options) const const
QList< T > | findChildren (const QRegularExpression &re, Qt::FindChildOptions options) const const
QList< T > | findChildren (const QString &name, Qt::FindChildOptions options) const const
bool | inherits (const char *className) const const
void | installEventFilter (QObject *filterObj)
bool | isWidgetType () const const
bool | isWindowType () const const
void | killTimer (int id)
virtual const QMetaObject * | metaObject () const const
void | moveToThread (QThread *targetThread)
QString | objectName () const const
void | objectNameChanged (const QString &objectName)
QObject * | parent () const const
QVariant | property (const char *name) const const
| Q_CLASSINFO (Name, Value)
| Q_DISABLE_COPY (Class)
| Q_DISABLE_COPY_MOVE (Class)
| Q_DISABLE_MOVE (Class)
| Q_EMIT Q_EMIT
| Q_ENUM (...)
| Q_ENUM_NS (...)
| Q_ENUMS (...)
| Q_FLAG (...)
| Q_FLAG_NS (...)
| Q_FLAGS (...)
| Q_GADGET Q_GADGET
| Q_INTERFACES (...)
| Q_INVOKABLE Q_INVOKABLE
| Q_NAMESPACE Q_NAMESPACE
| Q_NAMESPACE_EXPORT (EXPORT_MACRO)
| Q_OBJECT Q_OBJECT
| Q_PROPERTY (...)
| Q_REVISION Q_REVISION
| Q_SET_OBJECT_NAME (Object)
| Q_SIGNAL Q_SIGNAL
| Q_SIGNALS Q_SIGNALS
| Q_SLOT Q_SLOT
| Q_SLOTS Q_SLOTS
T | qFindChild (const QObject *obj, const QString &name)
QList< T > | qFindChildren (const QObject *obj, const QRegExp &regExp)
QList< T > | qFindChildren (const QObject *obj, const QString &name)
T | qobject_cast (const QObject *object)
T | qobject_cast (QObject *object)
| QT_NO_NARROWING_CONVERSIONS_IN_CONNECT QT_NO_NARROWING_CONVERSIONS_IN_CONNECT
void | removeEventFilter (QObject *obj)
void | setObjectName (const QString &name)
void | setParent (QObject *parent)
bool | setProperty (const char *name, const QVariant &value)
bool | signalsBlocked () const const
int | startTimer (int interval, Qt::TimerType timerType)
int | startTimer (std::chrono::milliseconds time, Qt::TimerType timerType)
QThread * | thread () const const

## Protected Member Functions
virtual Q_INVOKABLE void | doStart ()=0
void | emitFinished (const KDSoapMessage &reply, const KDSoapHeaders &replyHeaders)
Protected Member Functions inherited from QObject
virtual void | childEvent (QChildEvent *event)
virtual void | connectNotify (const QMetaMethod &signal)
virtual void | customEvent (QEvent *event)
virtual void | disconnectNotify (const QMetaMethod &signal)
bool | isSignalConnected (const QMetaMethod &signal) const const
int | receivers (const char *signal) const const
QObject * | sender () const const
int | senderSignalIndex () const const
virtual void | timerEvent (QTimerEvent *event)

## Additional Inherited Members
Static Public Member Functions inherited from QObject
QMetaObject::Connection | connect (const QObject *sender, const char *signal, const QObject *receiver, const char *method, Qt::ConnectionType type)
QMetaObject::Connection | connect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method, Qt::ConnectionType type)
QMetaObject::Connection | connect (const QObject *sender, PointerToMemberFunction signal, const QObject *context, Functor functor, Qt::ConnectionType type)
QMetaObject::Connection | connect (const QObject *sender, PointerToMemberFunction signal, const QObject *receiver, PointerToMemberFunction method, Qt::ConnectionType type)
QMetaObject::Connection | connect (const QObject *sender, PointerToMemberFunction signal, Functor functor)
bool | disconnect (const QMetaObject::Connection &connection)
bool | disconnect (const QObject *sender, const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method)
bool | disconnect (const QObject *sender, PointerToMemberFunction signal, const QObject *receiver, PointerToMemberFunction method)
QString | tr (const char *sourceText, const char *disambiguation, int n)
QString | trUtf8 (const char *sourceText, const char *disambiguation, int n)
Public Attributes inherited from QObject
typedef | QObjectList
Properties inherited from QObject
| objectName

## Detailed Description

KDSoapJob provides a job-based interface to handle asynchronous KD Soap calls.

For each SOAP operation, kdwsdl2cpp generates a corresponding KDSoapJob subclass. This makes it easier to manage multiple callers in the client application code calling the same functions, preventing callers processing results for calls made from another caller instead of their own calls.

For example, a call to getMothersDay (from the holidays example) using the conventional asynchronous API would look like this:

connect(client, &ServiceClass::getMothersDayDone, this, &MyClass::getMothersDayDone);
connect(client, &ServiceClass::getMothersDayError, this, &MyClass::getMothersDayError);
TNS__GetMothersDay params;
params.setYear(2012);
client->asyncGetMothersDay(params);
QObject::connect
QMetaObject::Connection connect(const QObject *sender, const char *signal, const QObject *receiver, const char *method, Qt::ConnectionType type)
QObject::qobject_cast
T qobject_cast(QObject *object)

In this example, all responses to getMothersDay made `client` will be received by the slots connected above. Using the job-based API, it becomes:

GetMothersDayJob* job = new GetMothersDayJob(client);
connect(job, &GetMothersDayJob::finished, this, &MyClass::getMothersDayDone);
TNS__GetMothersDay params;
params.setYear(2012);
job->setParameters(params);
job->start();

Now only the result of this specific getMothersDay call will be received by the slot.

Since
  1.2

Definition at line 52 of file KDSoapJob.h.

## Constructor & Destructor Documentation

## ◆ KDSoapJob()

KDSoapJob::KDSoapJob | ( | QObject * | parent = `nullptr` | ) |
| explicit

Constructs a KD Soap job.

Parameters

  parent | optional parent object

Definition at line 23 of file KDSoapJob.cpp.

## ◆ ~KDSoapJob()

KDSoapJob::~KDSoapJob | ( |  | ) |

Destructor.

Definition at line 30 of file KDSoapJob.cpp.

## Member Function Documentation

## ◆ doStart()

virtual Q_INVOKABLE void KDSoapJob::doStart | ( |  | ) |
| protectedpure virtual

## ◆ emitFinished()

void KDSoapJob::emitFinished | ( | const KDSoapMessage & | reply,
|  | const KDSoapHeaders & | replyHeaders
| ) |  |
| protected

Definition at line 55 of file KDSoapJob.cpp.

References QObject::deleteLater(), finished(), QObject::qobject_cast(), reply(), and replyHeaders().

## ◆ faultAsString()

QString KDSoapJob::faultAsString | ( |  | ) | const

A human-readable error string describing the fault if the reply message is a fault, an empty string otherwise.

Definition at line 80 of file KDSoapJob.cpp.

## ◆ finished

void KDSoapJob::finished | ( | KDSoapJob * | job | ) |
| signal

emitted when the job is completed, i.e. the reply for the job's request was received. To read the result, call reply() in the connected slot. Do not delete the job, the job will auto-delete itself. This behavior can be changed with setAutoDelete().

Parameters

  job | The job instance that emitted the signal

Referenced by emitFinished().

## ◆ isFault()

bool KDSoapJob::isFault | ( |  | ) | const

Returns whether the reply message (see reply()) represents a fault.

Definition at line 75 of file KDSoapJob.cpp.

## ◆ reply()

KDSoapMessage KDSoapJob::reply | ( |  | ) | const

Returns the reply message received from the SOAP server once the request was completed. Only valid once the request is completed and finished() was emitted.

Definition at line 65 of file KDSoapJob.cpp.

Referenced by emitFinished().

## ◆ replyHeaders()

KDSoapHeaders KDSoapJob::replyHeaders | ( |  | ) | const

Returns the reply headers received from the SOAP server once the request was completed. Only valid once the request is completed and finished() was emitted.

Since
  1.8

Definition at line 70 of file KDSoapJob.cpp.

Referenced by emitFinished().

## ◆ requestHeaders()

KDSoapHeaders KDSoapJob::requestHeaders | ( |  | ) | const

Returns the reply headers received from the SOAP server once the request was completed. Only valid once the request is completed and finished() was emitted.

Definition at line 35 of file KDSoapJob.cpp.

## ◆ setAutoDelete()

void KDSoapJob::setAutoDelete | ( | bool | enable | ) |

Defines whether the job should be automatically deleted or not.

Since
  1.8

Definition at line 50 of file KDSoapJob.cpp.

References QObject::qobject_cast().

## ◆ setRequestHeaders()

void KDSoapJob::setRequestHeaders | ( | const KDSoapHeaders & | headers | ) |

Sets request headers to be sent to the SOAP server. These are sent in addition to the persistent headers set via the client interface.

Since
  1.8

Definition at line 40 of file KDSoapJob.cpp.

References QObject::qobject_cast().

## ◆ start()

void KDSoapJob::start | ( |  | ) |

Starts the job. The job will emit finished() once done.

Definition at line 45 of file KDSoapJob.cpp.

References QMetaObject::invokeMethod(), and Qt::QueuedConnection.

The documentation for this class was generated from the following files:

- KDSoapJob.h
- KDSoapJob.cpp

© 2010-2024 Klarälvdalens Datakonsult AB (KDAB)
"The Qt, C++ and OpenGL Experts"
https://www.kdab.com/
https://www.kdab.com/development-resources/qt-tools/kd-soap/
Generated on Sun Jan 7 2024 11:47:36 for KD SOAP API Documentation by doxygen 1.9.8